unit Core;
interface
uses Windows, SysUtils, Classes, Forms, Menus, Dialogs, Buibui;

const OSDFont='Vera.ttf';

var HomeDir:string;
var MediaURL:string;
    AutoPlay:boolean;
var ReIndex:boolean;
    Params:string;
var HaveVideo:boolean;
    NativeWidth,NativeHeight:integer;
    PercentPos:integer;
    utiliserPercent:boolean;
    Fullscreen:boolean;
    OSDLevel:integer;

function EscapeParam(const Param:string):string;
procedure Init;
procedure Start;
procedure Stop;
procedure Restart;
procedure ForceStop;
function Running:boolean;
procedure Terminate;
procedure SendCommand(Command:string);
procedure SetOSDLevel(Level:integer);

implementation
uses Unit12, Unit1;

type TClientWaitThread=class(TThread)
                         private procedure ClientDone;
                         protected procedure Execute; override;
                         public hProcess:Cardinal;
                       end;
type TProcessor=class(TThread)
                  private Data:string;
                  private procedure Process;
                  protected procedure Execute; override;
                  public hPipe:Cardinal;
                end;

var ClientWaitThread:TClientWaitThread;
    Processor:TProcessor;
    ClientProcess,ReadPipe,WritePipe:Cardinal;
    FirstChance:boolean;
    FontPath:string;
procedure HandleInputLine(Line:string); forward;


function SplitLine(var Line:string):string;
var i:integer;
begin
  i:=Pos(#32,Line);
  if (length(Line)<72) OR (i<1) then begin
    Result:=Line;
    Line:='';
    exit;
  end;
  if(i>71) then begin
    Result:=Copy(Line,1,i-1);
    Delete(Line,1,i);
    exit;
  end;
  i:=72; while Line[i]<>#32 do dec(i);
  Result:=Copy(Line,1,i-1);
  Delete(Line,1,i);
end;

function EscapeParam(const Param:string):string;
begin
  if Pos(#32,Param)>0 then Result:=#34+Param+#34 else Result:=Param;
end;


procedure Init;
begin
  FontPath:=Form1.TempRep+'Vera.ttf';
  if FileExists(FontPath) then
    FontPath:=' -font '+EscapeParam(FontPath)
  else
    FontPath:='';
  HomeDir:=IncludeTrailingPathDelimiter(ExtractFileDir(ExpandFileName(ParamStr(0))));
end;

procedure Start;
var DummyPipe1,DummyPipe2:THandle;
    si:TStartupInfo;
    pi:TProcessInformation;
    sec:TSecurityAttributes;
    CmdLine,saturation,Brightness:string;
begin
  if ClientProcess<>0 then exit;
  if length(MediaURL)=0 then exit;

  FirstChance:=true;
  ClientWaitThread:=TClientWaitThread.Create(true);
  Processor:=TProcessor.Create(true);

  CmdLine:=EscapeParam(Form1.TempRep+'mplayer.exe')+' -quiet -vo directx:noaccel -slave -identify'
          +Form1.getDemuxerFromFilename(MediaURL)+' -wid '+IntToStr(Form12.Panel1.Handle)+' -colorkey 0x101010'
          +' -nokeepaspect -framedrop -osdlevel 0 -loop 0 -autosync 100';
  if ReIndex then CmdLine:=CmdLine+' -idx';


  Params:=' ';
  Params:=Params+'-af volume='+IntToStr(StrToInt(Form1.Label18.Caption) div 4);
  if Form1.sCheckBox3.Checked then
    Params:=Params+',volnorm';
  if Form1.sCheckBox2.Checked then
    Params:=Params+',extrastereo=3.6';
  if Form1.nb_audio<>'0' then
    Params:=Params+' -aid '+Form1.nb_audio;

  Brightness:=Form1.Label9.Caption;
  Brightness:=IntToStr(StrToInt(Brightness) div 20)+IntToStr((StrToInt(Brightness) div 2)-((StrToInt(Brightness) div 20) * 10));
  if Brightness='00' then Brightness:='0';
  saturation:=IntToStr(Form1.ScrollBar6.Position);
  saturation:=IntToStr(StrToInt(saturation) div 30)+'.'+IntToStr((StrToInt(saturation) div 3)-((StrToInt(saturation) div 30) * 10));
  if saturation='1.2' then saturation:='1.0';
//  Params:=Params+' -vf eq2=1.0:1.'+Form1.Label25.Caption+':0.'+Brightness+':'+saturation;

//  if Form1.dxCheckbox7.Checked then
//    Params:=Params+' -vf-add ivtc=1';
//  if Form1.dxCheckbox8.Checked then
//    Params:=Params+' -vf-add lavcdeint';
//  if Form1.dxCheckbox2.Checked=true then
//    Params:=Params+' -ofps '+StringReplace(Form1.Edit3.Text, ',', '.', [rfReplaceAll])+' ';
  if Form1.dxCheckbox3.Checked then
    Params:=Params+' -nosound '
  else
    Params:=Params+' -ao dsound ';

  if length(Params)>0 then
    CmdLine:=CmdLine+#32+Params+' -vo directx:noaccel ';
  CmdLine:=CmdLine+' '+MediaURL+' ';

  HaveVideo:=true;
  NativeWidth:=0;
  NativeHeight:=0;
  PercentPos:=0;
  Fullscreen:=false;
  OSDLevel:=1;

  with sec do begin
    nLength:=sizeof(sec);
    lpSecurityDescriptor:=nil;
    bInheritHandle:=true;
  end;
  CreatePipe(ReadPipe,DummyPipe1,@sec,0);

  with sec do begin
    nLength:=sizeof(sec);
    lpSecurityDescriptor:=nil;
    bInheritHandle:=true;
  end;
  CreatePipe(DummyPipe2,WritePipe,@sec,0);

  FillChar(si,sizeof(si),0);
  si.cb:=sizeof(si);
  si.dwFlags:=STARTF_USESTDHANDLES;
  si.hStdInput:=DummyPipe2;
  si.hStdOutput:=DummyPipe1;
  si.hStdError:=DummyPipe1;
  ChDir(Form1.TempRep);
  CreateProcess(nil,PChar(CmdLine),nil,nil,true,DETACHED_PROCESS,nil,PChar(Form1.TempRep),si,pi);

  CloseHandle(DummyPipe1);
  CloseHandle(DummyPipe2);

  ClientProcess:=pi.hProcess;
  ClientWaitThread.hProcess:=ClientProcess;
  Processor.hPipe:=ReadPipe;

  ClientWaitThread.Resume;
  Processor.Resume;
  Form12.SetupStart;
end;

procedure TClientWaitThread.ClientDone;
begin
  ClientProcess:=0;
  CloseHandle(ReadPipe); ReadPipe:=0;
  CloseHandle(WritePipe); WritePipe:=0;
  ClientWaitThread.Terminate;
  Fullscreen:=false;
  Form12.SetupStop;
end;

procedure TClientWaitThread.Execute;
begin
  WaitForSingleObject(hProcess,INFINITE);
  Synchronize(ClientDone);
end;

procedure TProcessor.Process;
var EOL:integer;
begin
  EOL:=Pos(#10,Data);
  while EOL>0 do begin
    HandleInputLine(Copy(Data,1,EOL-1));
    Delete(Data,1,EOL);
    EOL:=Pos(#10,Data);
  end;
end;

procedure TProcessor.Execute;
const BufSize=1024;
var Buffer:array[0..BufSize]of char;
    BytesRead:cardinal;
begin
  Data:='';
  repeat
    BytesRead:=0;
    if not ReadFile(hPipe,Buffer[0],BufSize,BytesRead,nil) then break;
    Buffer[BytesRead]:=#0;
    Data:=Data+Buffer;
    Synchronize(Process);
  until BytesRead=0;
end;


function Running:boolean;
begin
  Result:=(ClientProcess<>0);
end;

function SecondsToString(Seconds: integer): string;
var i1, i2: integer;
begin
   i1:=(Seconds DIV 60);
   i2:=(Seconds - (i1*60));
//   If i1 DIV 60 > 0 then
      Result:=FormatFloat('00',i1 DIV 60)+':'+FormatFloat('00',i1 MOD 60)+':'+FormatFloat('00',i2);
//   else
//      Result:=FormatFloat('00',i1)+':'+FormatFloat('00',i2);
end;


procedure Stop;
begin
  if FirstChance then begin
    SendCommand('quit');
    FirstChance:=false;
  end else
    Terminate;
end;

procedure Terminate;
begin
  if ClientProcess=0 then exit;
  TerminateProcess(ClientProcess,cardinal(-1));
end;

procedure ForceStop;
begin
  if FirstChance then begin
    SendCommand('quit');
    FirstChance:=false;
    if WaitForSingleObject(ClientProcess,1000)<>WAIT_TIMEOUT then exit;
  end;
  Terminate;
end;

procedure SendCommand(Command:string);
var Dummy:cardinal;
begin
  if (ClientProcess=0) OR (WritePipe=0) then exit;
  Command:=Command+#10;
  WriteFile(WritePipe,Command[1],length(Command),Dummy,nil);
end;

procedure SetOSDLevel(Level:integer);
begin
  if Level<0 then OSDLevel:=OSDLevel+1
             else OSDLevel:=Level;
  OSDLevel:=OSDLevel AND 3;
  SendCommand('osd '+IntToStr(OSDLevel));
end;

procedure Restart;
var LastPos,LastOSD:integer;
begin
  if not Running then exit;
  LastPos:=PercentPos;
  LastOSD:=OSDLevel;
  ForceStop;
  Sleep(50); // wait for the processing threads to finish
  Application.ProcessMessages;
  Start;
  SendCommand('seek '+IntToStr(LastPos)+' 1');
  SetOSDLevel(LastOSD);
  Form12.QueryPosition;
end;

////////////////////////////////////////////////////////////////////////////////



procedure HandleInputLine(Line:string);
var
  r,i,j,p:integer;

  procedure SubMenu_Add(Menu:TMenuItem; ID,SelectedID:integer; Handler:TNotifyEvent);
  var Item:TMenuItem;
  begin
    Item:=TMenuItem.Create(Menu);
    with Item do begin
      Caption:=IntToStr(ID);
      Tag:=ID;
      GroupIndex:=$0A;
      RadioItem:=true;
      if ID=SelectedID then Checked:=true else
      if (SelectedID<0) AND (Menu.Count=0) then Checked:=true;
      OnClick:=Handler;
    end;
    Menu.Add(Item);
    Menu.Enabled:=true;
  end;


  function CheckNativeResolutionLine:boolean;
  begin
    Result:=false;
    if Copy(Line,1,5)<>'VO: [' then exit;
    p:=Pos(' => ',Line); if p=0 then exit; Delete(Line,1,p+3);
    p:=Pos(#32,Line);    if p=0 then exit; SetLength(Line,p-1);
    p:=Pos('x',Line);    if p=0 then exit;
    Val(Copy(Line,1,p-1),i,r); if (r<>0) OR (i<16) OR (i>=4096) then exit;
    Val(Copy(Line,p+1,5),j,r); if (r<>0) OR (j<16) OR (j>=4096) then exit;
    NativeWidth:=i; NativeHeight:=j;
    //Form12.VideoSizeChanged;
    Result:=true;
  end;

  function CheckNoVideo:boolean;
  begin
    Result:=false;
    if Line<>'Video: no video' then exit;
    HaveVideo:=false;
    Result:=true;
  end;

  function CheckStartPlayback:boolean;
  begin
    Result:=false;
    if Line<>'Starting playback...' then exit;
    Form12.SetupPlay;
    Result:=true;
  end;


begin
  Line:=Trim(Line);
  if Copy(Line,1,21)='ANS_PERCENT_POSITION=' then begin
    Val(Copy(Line,22,4),i,r);
    if (r=0) AND (i>=0) AND (i<=100) then begin
      PercentPos:=i;
      if ((Lowercase(ExtractFileExt(Form1.Edit1.Text))='.vob') and (Form1.VidInfo.dsMediaDuration<600)) then begin
        Line:=IntToStr(PercentPos*Form1.VidInfo.dsMediaDuration div 100);
        Form12.Position:=StrToInt(Line);
        Form12.Label8.Caption:=SecondsToString(StrToInt(Line));
      end;
      Form12.UpdateSeekBar;
    end;
    exit;
  end;
  if Copy(Line,1,18)='ANS_TIME_POSITION=' then begin
   if ((Lowercase(ExtractFileExt(Form1.Edit1.Text))<>'.vob') or (Form1.VidInfo.dsMediaDuration>=600)) then begin
     try
       Line:=Bui_ExtraitMot(Line,2,'=');
       Line:=Bui_ExtraitMot(Line,1,'.');
        if Form1.VidInfo.dsMediaTimeShift=-1 then
        begin
          Form1.VidInfo.dsMediaTimeShift:=StrToInt(Line);
          Form12.Position:=0;
          Form12.Label8.Caption:=SecondsToString(0);
        end
        else
        begin
          if StrToInt(Line)<0 then Line:='0';
          Form12.Position:=StrToInt(Line)-Form1.VidInfo.dsMediaTimeShift;
          Form12.Label8.Caption:=SecondsToString(StrToInt(Line)-Form1.VidInfo.dsMediaTimeShift);
        end;
     except
       Form12.Label8.Caption:=Form12.Label8.Caption;
     end;
     exit;
   end;
  end;
  if not CheckNativeResolutionLine then
  if not CheckNoVideo then
  if not CheckStartPlayback then
  ;
end;


begin
  DecimalSeparator:='.';
  NativeWidth:=0; NativeHeight:=0;
  MediaURL:='';
  ReIndex:=false;
  Params:='';
end.
