unit Unit7;

interface

uses
  SysUtils, Classes, Controls, Forms, Windows, dxCore, dxButton, StdCtrls,
  Dialogs, ShellAPI, Registry, Graphics, ExtCtrls, futureImage, jpeg, Buibui,
  sSkinProvider, sEdit, Buttons, sBitBtn, sLabel, sPanel;

type
  TWindowsVersion = (twvUnknow, twvWin31, twvWin951, twvWin952, tWvWin981,
                     tWvWin982, tWvWinme, tWvWin9x, tWvWinnt35, tWvWinnt4,
                     tWvWin2k, tWvWinxp, tWvWinnt);

  TForm7 = class(TForm)
    dxButton15: TsBitBtn;
    dxButton5: TsBitBtn;
    Image15: TfutureImage;
    Image16: TfutureImage;
    Image1: TfutureImage;
    dxButton13: TsBitBtn;
    sSkinProvider1: TsSkinProvider;
    sPanel1: TsPanel;
    Label9: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    Label17: TLabel;
    Label16: TLabel;
    Label14: TLabel;
    Label12: TLabel;
    Image9: TfutureImage;
    Image8: TfutureImage;
    Image7: TfutureImage;
    Image6: TfutureImage;
    Image5: TfutureImage;
    Image4: TfutureImage;
    Image3: TfutureImage;
    Image2: TfutureImage;
    futureImage1: TfutureImage;
    Edit9: TsEdit;
    Edit7: TsEdit;
    Edit6: TsEdit;
    Edit5: TsEdit;
    Edit4: TsEdit;
    Edit2: TsEdit;
    Edit17: TsEdit;
    Edit16: TsEdit;
    Edit14: TsEdit;
    Edit12: TsEdit;
    sLabel1: TsLabel;
    sPanel2: TsPanel;
    Label8: TLabel;
    Label25: TLabel;
    Label15: TLabel;
    Label13: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Image14: TfutureImage;
    Image13: TfutureImage;
    Image12: TfutureImage;
    Image11: TfutureImage;
    Image10: TfutureImage;
    Edit8: TsEdit;
    Edit23: TsEdit;
    Edit15: TsEdit;
    Edit13: TsEdit;
    Edit11: TsEdit;
    Edit10: TsEdit;
    sLabel2: TsLabel;
    sPanel3: TsPanel;
    Label1: TLabel;
    Edit1: TsEdit;
    Label3: TLabel;
    Edit3: TsEdit;
    sLabel3: TsLabel;
    procedure Yes(ima:TFutureImage; mess:string);
    procedure No(ima:TFutureImage; mess:string);
    procedure Bof(ima:TFutureImage; mess:string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dxButton5Click(Sender: TObject);
    procedure dxButton15Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Image6Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure Image4Click(Sender: TObject);
    procedure Image5Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image7Click(Sender: TObject);
    procedure Image8Click(Sender: TObject);
    procedure Image9Click(Sender: TObject);
    procedure Image10Click(Sender: TObject);
    procedure Image14Click(Sender: TObject);
    procedure Image12Click(Sender: TObject);
    procedure Image13Click(Sender: TObject);
    procedure Image11Click(Sender: TObject);
    procedure futureImage1Click(Sender: TObject);
    procedure dxButton13Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    Lang_VBR, Lang_AudioCodec, Lang_VideoCodec : string;
    Lang_Width, Lang_Height, Lang_FPS : string;
    Lang_Bitrate, Lang_PPS, Lang_OK, Lang_BOF, Lang_KO, Lang_FAILED : string;
    Lang_DivideBy16 : string;
  end;

var
  Form7: TForm7;

implementation

uses Unit1;

{$R *.dfm}

{ TForm1 }



//*************************************************************
//       Fonction Trouvant la Version de Windows
//*************************************************************
function WindowsVersion:TWindowsVersion;
var
    VI       : TOSVersionInfo;
    WinVersion : TWindowsVersion;
begin
    VI.dwOSVersionInfoSize:= SizeOf(VI);
    GetVersionEx(VI);

    WinVersion := twvunknow ;
    case VI.dwPlatformID of
    VER_PLATFORM_WIN32s: WinVersion := tWvWin31;

    VER_PLATFORM_WIN32_WINDOWS:
        case VI.dwMinorVersion of
                0 : if Trim(VI.szCSDVersion[1]) = 'B' then
                        WinVersion:= tWvWin952
                    else
                        WinVersion:= tWvWin951;
             10 : if Trim(VI.szCSDVersion[1]) = 'A' then
                    WinVersion:= tWvWin982
                    else
                    WinVersion:= tWvWin981;
             90 : if (VI.dwBuildNumber = 73010104) then
                    WinVersion:= tWvWinme;

             else WinVersion:= tWvWin9x;
        end;

    VER_PLATFORM_WIN32_NT:
        case VI.dwMajorVersion of
            3 : WinVersion:= tWvWinnt35;
            4 : WinVersion:= tWvWinnt4;
            5 : case VI.dwMinorVersion of
                    0 : WinVersion:= tWvWin2k;
                    1 : WinVersion:= tWvWinxp;
                    else WinVersion:= tWvWinnt
                end;
        end;
    end;
    result := WinVersion;
end;

function WindowsVersionStr:string;
var
     Winver : TWindowsVersion;
begin
// on rcupre le rsultat ainsi:
    // VERSION DE WINDOWS
    WinVer := WindowsVersion;
    Result := 'Inconnu';
    case WinVer of
    twvunknow    : Result :='Inconnu';
    twvwin31    : Result :='Windows 3.1';
    twvwin951    : Result :='Windows 95 OSR 1';
    twvwin952    : Result :='Windows 95 OSR 2';
    twvwin981    : Result :='Windows 98 OSR 1';
    twvwin982    : Result :='Windows 98 OSR 2';
    twvwinme    : Result :='Windows Me';
    twvwin9x    : Result :='Windows 9x'; // Si Windows Inconnu parmi les Win9x
    twvwinnt35  : Result :='Windows NT 3.5';
    twvwinnt4    : Result :='Windows NT 4';
    twvwin2k    : Result :='Windows 2000';
    twvwinxp    : Result :='Windows XP';
    twvwinnt    : Result :='Windows NT'; // Si Windows Inconnu parmi les WinNT
    end;
end;




function SecondsToString(Seconds: integer): string;
var i1, i2: integer;
begin
   i1:=(Seconds DIV 60);
   i2:=(Seconds - (i1*60));
   If i1 DIV 60 > 0 then
      Result:=FormatFloat('00',i1 DIV 60)+':'+FormatFloat('00',i1 MOD 60)+':'+FormatFloat('00',i2)
   else
      Result:=FormatFloat('00',i1)+':'+FormatFloat('00',i2);
end;



procedure TForm7.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.Enabled:=true;
end;




Procedure ExecuteWait(Programme:string; Params:string; Showornot:integer);
var ShExecInfo : TShellExecuteInfo;
begin
    FillChar(ShExecInfo, SizeOf(ShExecInfo), 0);
    with ShExecInfo do
    begin
        cbSize := SizeOf(ShExecInfo);
        fMask  := SEE_MASK_NOCLOSEPROCESS;
        lpFile := PChar(Programme);      { le nom du programme }
        lpVerb := 'open';
        lpParameters := PChar(Params);
        nShow  := Showornot;
    end;
    if ShellExecuteEx(@ShExecInfo) then
    begin       { on execute le programme }
        WaitForSingleObject(ShExecInfo.hProcess, INFINITE); { on attends un temps indefinie que l'appli s'arrete }
    end;
end;




procedure TForm7.dxButton5Click(Sender: TObject);
begin
  Form7.Close;
end;

procedure TForm7.dxButton15Click(Sender: TObject);
var
  co:string;
begin
  co:='mailto:wildelnab31@yahoo.fr?subject='+dxButton15.Caption+'&body=';
  co:=co+Form7.Caption+'%0D%0A';
  co:=co+sLabel1.Caption+'%0D%0A';
  co:=co+Label2.Caption+' '+Edit2.Text+'%0D%0A';
  co:=co+Label4.Caption+' '+Edit4.Text+'%0D%0A';
  co:=co+Label5.Caption+' '+Edit5.Text+'%0D%0A';
  co:=co+Label6.Caption+' '+Edit6.Text+'%0D%0A';
  co:=co+Label7.Caption+' '+Edit7.Text+'%0D%0A';
  co:=co+Label9.Caption+' '+Edit9.Text+'%0D%0A';
  co:=co+sLabel2.Caption+'%0D%0A';
  co:=co+Label25.Caption+' '+Edit23.Text+'%0D%0A';
  co:=co+Label10.Caption+' '+Edit10.Text+'%0D%0A';
  co:=co+Label11.Caption+' '+Edit11.Text+'%0D%0A';
  co:=co+Label12.Caption+' '+Edit12.Text+'%0D%0A';
  co:=co+Label13.Caption+' '+Edit13.Text+'%0D%0A';
  co:=co+sLabel3.Caption+'%0D%0A';
  co:=co+Label1.Caption+' '+Edit1.Text+'%0D%0A';
  co:=co+Label3.Caption+' '+Edit3.Text+'%0D%0A';
  co:=co+'File : '+Form1.Edit1.Text+'%0D%0A';
  co:=co+'Version : '+Form1.Caption+'%0D%0A';
  ShellExecute(0, nil, PChar(co), nil, nil, SW_SHOW);
end;




procedure TForm7.Yes(ima:TFutureImage; mess:string);
begin
  if ima.Hint<>Lang_FAILED+' '+Form1.getShortDevice then
  begin
    ima.Picture.Bitmap.Assign(Image15.Picture);
    ima.PictureOut.Bitmap.Assign(Image15.PictureOut);
    if mess<>'' then
      ima.Hint:=mess+' '+Form1.getShortDevice
    else
      ima.Hint:=Lang_OK+' '+Form1.getShortDevice;
    ima.ShowHint:=true;
    ima.Center:=true;
  end;
end;

procedure TForm7.No(ima:TFutureImage; mess:string);
begin
  if ima.Hint<>Lang_FAILED+' '+Form1.getShortDevice then
  begin
    ima.Picture.Bitmap.Assign(Image16.Picture);
    ima.PictureOut.Bitmap.Assign(Image16.PictureOut);
    if mess<>'' then
      ima.Hint:=mess+' '+Form1.getShortDevice
    else
      ima.Hint:=Lang_KO+' '+Form1.getShortDevice;
    ima.ShowHint:=true;
    ima.Center:=false;
  end;
end;

procedure TForm7.Bof(ima:TFutureImage; mess:string);
begin
  if ima.Hint<>Lang_FAILED+' '+Form1.getShortDevice then
  begin
    ima.Picture.Bitmap.Assign(Image1.Picture);
    ima.PictureOut.Bitmap.Assign(Image1.PictureOut);
    if mess<>'' then
      ima.Hint:=mess+' '+Form1.getShortDevice
    else
      ima.Hint:=Lang_BOF+' '+Form1.getShortDevice;
    ima.ShowHint:=true;
  end;
end;


procedure Clearer(ima:TFutureImage);
begin
  ima.Picture:=nil;
  ima.PictureOut:=nil;
  ima.ShowHint:=false;
  ima.Hint:='';
  ima.Center:=true;
end;


procedure Nettoyer(ed:TEdit; im:TFutureImage; unk:integer);
begin
  if ((ed.Text='') or (UpperCase(ed.Text)='UNKNOWN') or (ed.Text='0')) then
  begin
    if unk=0 then ed.Text:='0' else ed.Text:='Unknown';
    if Form1.getShortDevice='Archos' then
      Form7.Bof(im,Form7.Lang_FAILED);
  end;
end;



procedure TForm7.FormActivate(Sender: TObject);
var
  Reg:TRegistry;
  tempo:double;
begin
  Clearer(Image2);
  Clearer(futureImage1);
  Clearer(Image3);
  Clearer(Image4);
  Clearer(Image5);
  Clearer(Image6);
  Clearer(Image7);
  Clearer(Image8);
  Clearer(Image9);
  Clearer(Image10);
  Clearer(Image11);
  Clearer(Image12);
  Clearer(Image13);
  Clearer(Image14);


  with Form1 do
  begin
   If (VidInfo.dsMediaVideoMajorType <> 'ERROR') OR (VidInfo.dsMediaVideoMajorType <> 'FILE NOT FOUND') then
   Begin
      Form7.Edit2.Text := VidInfo.dsMediaVideoMajorType;
      if Form7.Edit2.Text='ERROR' then
        Form7.Edit2.Text := 'Video';
      Form7.Edit4.Text := SecondsToString(trunc(VidInfo.dsMediaDuration));
      Form7.Edit17.Text := FloatToStrF(VidInfo.dsMediaVideoAspect,ffFixed,5,4);
      Form7.Edit5.Text := VidInfo.dsMediaVideoFourCC;
      Form7.Edit6.Text := VidInfo.dsMediaVideoWidth;
      Form7.Edit7.Text := VidInfo.dsMediaVideoHeight;
      Form7.Edit9.Text := VidInfo.dsMediaVideoComp;
      Form7.Edit10.Text := VidInfo.dsMediaAudioFormatTag;
      if Edit10.Text='MPEGLAYER3' then
        Edit10.Text:='MP3';
      Form7.Edit11.Text := VidInfo.dsMediaAudioHertz;
      Form7.Edit13.Text := VidInfo.dsMediaAudioChannels;
      Form7.Edit14.Text := IntToStr(VidInfo.dsMediaBitrate);
      Form7.Edit23.Text := VidInfo.dsMediaAudioMajorType;
      Form7.Edit8.Text := IntToStr(VidInfo.dsMediaAudioStreams);
      Form7.Edit12.Text := FloatToStrF(VidInfo.FPS,ffFixed,5,3);
      tempo:=0;
      try
        tempo:=StrToInt(VidInfo.dsMediaVideoWidth)*StrToInt(VidInfo.dsMediaVideoHeight);
        tempo:=tempo*VidInfo.FPS;
      except
        on EConvertError do tempo:=0;
      end;
      Edit16.Text:=FloatToStrF(tempo,ffFixed,16,0);
      if Edit10.Text<>'' then
      begin
        if VidInfo.dsMediaAudioVBR=true then
          Form7.Edit15.Text := IntToStr(VidInfo.dsMediaAudioBitrate)+' (VBR)'
        else
          Form7.Edit15.Text := IntToStr(VidInfo.dsMediaAudioBitrate)+' (CBR)';
      end;
      Nettoyer(Edit9, Image6, 1);
      Nettoyer(Edit6, Image4, 0);
      Nettoyer(Edit7, Image5, 0);
//      Nettoyer(Edit4, Image2, 1);
      Nettoyer(Edit17, futureImage1, 1);
      Nettoyer(Edit12, Image7, 1);
      Nettoyer(Edit14, Image8, 0);
      Nettoyer(Edit16, Image9, 0);
      Nettoyer(Edit10, Image10, 1);
      Nettoyer(Edit15, Image14, 0);
      Nettoyer(Edit13, Image12, 0);
      Nettoyer(Edit8, Image13, 0);
      Nettoyer(Edit11, Image11, 0);

      if Edit13.Text='1' then Edit13.Text:='Mono';
      if Edit13.Text='2' then Edit13.Text:='Stereo';
   end;
  end;
  Reg:=TRegistry.Create(KEY_READ);
  Reg.RootKey:=HKEY_LOCAL_MACHINE;
  if Reg.OpenKey('Software\Microsoft\DirectX', false) then
  begin
    if Reg.ValueExists('Version') then
      Edit1.Text:=Reg.ReadString('Version');
    Reg.CloseKey;
  end;
  Reg.Free;
  Edit3.Text:=WindowsVersionStr();


 If (Form1.VidInfo.dsMediaVideoMajorType <> 'ERROR') OR (Form1.VidInfo.dsMediaVideoMajorType <> 'FILE NOT FOUND') then
 Begin
  if Form1.getShortDevice='Archos' then
  begin

    if ((Uppercase(Edit5.Text)='DX50') or (Uppercase(Edit5.Text)='DIVX') or (Uppercase(Edit5.Text)='XVID') or (Uppercase(Edit5.Text)='FFMP')) then
    begin
      Yes(Image3,'');
      Yes(Image6,'');
    end
    else
    begin
      No(Image6, Lang_VideoCodec);
      No(Image3,Lang_VideoCodec);
    end;

    if (Uppercase(Edit10.Text)='MP3') then
      Yes (Image10,'')
    else if (Uppercase(Edit10.Text)='ADPCM') then
      Bof (Image10, Lang_BOF)
    else if (Uppercase(Edit10.Text)='IMAADPCM') then
      Bof (Image10, Lang_BOF)
    else
      No(Image10, Lang_AudioCodec);
    if (Form1.VidInfo.dsMediaAudioVBR=true) then
      No(Image14, Lang_VBR);

    if Form1.Device='Archos AV100/AV300 series' then
    begin
//      if Video=true then
//      begin
        Yes(Image2,'');
        Yes(futureImage1,'');
        if Form1.VidInfo.FPS<=32 then Yes(Image7,'') else No(Image7, Lang_FPS);
        if StrToInt(Edit6.Text)<=640 then Yes(Image4,'') else No(Image4, Lang_Width);
        if StrToInt(Edit7.Text)<=480 then Yes(Image5,'') else No(Image5, Lang_Height);
        if ((Image4.Center=true) and (((StrToInt(Edit6.Text) div 16) * 16)<>StrToInt(Edit6.Text))) then Bof(Image4,Lang_DivideBy16);
        if ((Image5.Center=true) and (((StrToInt(Edit7.Text) div 16) * 16)<>StrToInt(Edit7.Text))) then Bof(Image5,Lang_DivideBy16);
        if Form1.VidInfo.dsMediaBitrate<3600 then Yes(Image8,'') else Bof(Image8, Lang_Bitrate);
        if tempo<=5900000 then Yes(Image9,'') else No(Image9, Lang_PPS);
//      end;
//      if Audio=true then
//      begin
        if Edit8.Text='1' then Yes(Image13,'') else No(Image13,'');
        if ((StrToInt(Edit11.Text)>44100) or (StrToInt(Edit11.Text)<11025)) then Bof(Image11,'') else Yes (Image11,'');
        if (Edit13.Text='Stereo') then Yes (Image12,'') else No(Image12, '');
        if (Edit13.Text='Mono') then Bof (Image12,'');
        if (Image14.Center=true) then if ((Form1.VidInfo.dsMediaAudioBitrate>256) or (Form1.VidInfo.dsMediaAudioBitrate<32)) then Bof(Image14,'') else Yes (Image14,'');
//      end;
    end
    else if ((Form1.Device='Archos AV400/PMA400 series') or (Form1.Device='Archos AV500/Gmini500 series') or (Form1.Device='Archos AV700 series')) then
    begin
//      if Video=true then
//      begin
        Yes(Image2,'');
        Yes(futureImage1,'');
        if Form1.VidInfo.FPS<=32 then Yes(Image7,'') else No(Image7, Lang_FPS);
        if StrToInt(Edit6.Text)<=720 then Yes(Image4,'') else No(Image4, Lang_Width);
        if StrToInt(Edit7.Text)<=576 then Yes(Image5,'') else No(Image5, Lang_Height);
        if ((Image4.Center=true) and (((StrToInt(Edit6.Text) div 16) * 16)<>StrToInt(Edit6.Text))) then Bof(Image4,Lang_DivideBy16);
        if ((Image5.Center=true) and (((StrToInt(Edit7.Text) div 16) * 16)<>StrToInt(Edit7.Text))) then Bof(Image5,Lang_DivideBy16);
        if Form1.VidInfo.dsMediaBitrate<3600 then Yes(Image8,'') else Bof(Image8, Lang_Bitrate);
        if tempo<=10200000 then Yes(Image9,'') else No(Image9,Lang_PPS);
//      end;
//      if Audio=true then
//      begin
        if Edit8.Text='1' then Yes(Image13,'') else No(Image13,'');
        if ((StrToInt(Edit11.Text)>44100) or (StrToInt(Edit11.Text)<11025)) then Bof(Image11,'') else Yes (Image11,'');
        if (Edit13.Text='Stereo') then Yes (Image12,'') else No(Image12,'');
        if (Edit13.Text='Mono') then Bof (Image12,'');
        if (Image14.Center=true) then if ((Form1.VidInfo.dsMediaAudioBitrate>320) or (Form1.VidInfo.dsMediaAudioBitrate<32)) then Bof(Image14,'') else Yes (Image14,'');
//      end;
    end
    else if Form1.Device='Archos Gmini400' then
    begin
//      if Video=true then
//      begin
        Yes(Image2,'');
        Yes(futureImage1,'');
        if Form1.VidInfo.FPS<=32 then Yes(Image7,'') else No(Image7,Lang_FPS);
        if StrToInt(Edit6.Text)<=720 then Bof(Image4,'') else No(Image4,Lang_Width);
        if StrToInt(Edit6.Text)<=640 then Yes(Image4,'');
        if StrToInt(Edit7.Text)<=560 then Bof(Image5,'') else No(Image5,Lang_Height);
        if StrToInt(Edit7.Text)<=480 then Yes(Image5,'');
        if ((Image4.Center=true) and (((StrToInt(Edit6.Text) div 16) * 16)<>StrToInt(Edit6.Text))) then Bof(Image4,Lang_DivideBy16);
        if ((Image5.Center=true) and (((StrToInt(Edit7.Text) div 16) * 16)<>StrToInt(Edit7.Text))) then Bof(Image5,Lang_DivideBy16);
        if Form1.VidInfo.dsMediaBitrate<3600 then Yes(Image8,'') else Bof(Image8,Lang_Bitrate);
        if tempo<=7800000 then Yes(Image9,'') else No(Image9,Lang_PPS);
//      end;
//      if Audio=true then
//      begin
        if Edit8.Text='1' then Yes(Image13,'') else No(Image13,'');
        if ((StrToInt(Edit11.Text)>44100) or (StrToInt(Edit11.Text)<11025)) then Bof(Image11,'') else Yes (Image11,'');
        if (Edit13.Text='Stereo') then Yes (Image12,'') else No(Image12,'');
        if (Edit13.Text='Mono') then Bof (Image12,'');
        if (Image14.Center=true) then if ((Form1.VidInfo.dsMediaAudioBitrate>320) or (Form1.VidInfo.dsMediaAudioBitrate<32)) then Bof(Image14,'') else Yes (Image14,'');
//      end;
    end
    else if Form1.Device='Archos JBMM10/20 series' then
    begin
      if ((Uppercase(Edit5.Text)='DX50') or (Uppercase(Edit5.Text)='DIVX')) then
      begin
        Yes(Image3,'');
        Yes(Image6,'');
      end
      else
      begin
        No(Image3, Lang_VideoCodec);
        No(Image6, Lang_VideoCodec);
      end;
//      if Video=true then
//      begin
        Yes(Image2,'');
        Yes(futureImage1,'');
        if Form1.VidInfo.FPS<=25.0 then Yes(Image7,'') else No(Image7,Lang_FPS);
        if StrToInt(Edit6.Text)<=352 then Yes(Image4,'') else No(Image4,Lang_Width);
        if StrToInt(Edit7.Text)<=288 then Yes(Image5,'') else No(Image5,Lang_Height);
        if ((Image4.Center=true) and (((StrToInt(Edit6.Text) div 16) * 16)<>StrToInt(Edit6.Text))) then Bof(Image4,Lang_DivideBy16);
        if ((Image5.Center=true) and (((StrToInt(Edit7.Text) div 16) * 16)<>StrToInt(Edit7.Text))) then Bof(Image5,Lang_DivideBy16);
        if Form1.VidInfo.dsMediaBitrate<2400 then Yes(Image8,'') else Bof(Image8,Lang_Bitrate);
        if tempo<=2600000 then Yes(Image9,'') else No(Image9,Lang_PPS);
//      end;
//      if Audio=true then
//      begin
        if Edit8.Text='1' then Yes(Image13,'') else No(Image13,'');
        if ((StrToInt(Edit11.Text)>44100) or (StrToInt(Edit11.Text)<11025)) then Bof(Image11,'') else Yes (Image11,'');
        if (Edit13.Text='Stereo') then Yes (Image12,'') else No(Image12,'');
        if (Edit13.Text='Mono') then Bof (Image12,'');
        if (Image14.Center=true) then if ((Form1.VidInfo.dsMediaAudioBitrate>256) or (Form1.VidInfo.dsMediaAudioBitrate<32)) then Bof(Image14,'') else Yes (Image14,'');
//      end;
    end;
  end;
 End;
end;





procedure TForm7.Image6Click(Sender: TObject);
begin
  if Image6.Hint<>'' then
    ShowMessage(Image6.Hint);
end;

procedure TForm7.Image3Click(Sender: TObject);
begin
  if Image3.Hint<>'' then
    ShowMessage(Image3.Hint);
end;

procedure TForm7.Image4Click(Sender: TObject);
begin
  if Image4.Hint<>'' then
    ShowMessage(Image4.Hint);
end;

procedure TForm7.Image5Click(Sender: TObject);
begin
  if Image5.Hint<>'' then
    ShowMessage(Image5.Hint);
end;

procedure TForm7.Image2Click(Sender: TObject);
begin
  if Image2.Hint<>'' then
    ShowMessage(Image2.Hint);
end;

procedure TForm7.Image7Click(Sender: TObject);
begin
  if Image7.Hint<>'' then
    ShowMessage(Image7.Hint);
end;

procedure TForm7.Image8Click(Sender: TObject);
begin
  if Image8.Hint<>'' then
    ShowMessage(Image8.Hint);
end;

procedure TForm7.Image9Click(Sender: TObject);
begin
  if Image9.Hint<>'' then
    ShowMessage(Image9.Hint);
end;

procedure TForm7.Image10Click(Sender: TObject);
begin
  if Image10.Hint<>'' then
    ShowMessage(Image10.Hint);
end;

procedure TForm7.Image14Click(Sender: TObject);
begin
  if Image14.Hint<>'' then
    ShowMessage(Image14.Hint);
end;

procedure TForm7.Image12Click(Sender: TObject);
begin
  if Image12.Hint<>'' then
    ShowMessage(Image12.Hint);
end;

procedure TForm7.Image13Click(Sender: TObject);
begin
  if Image13.Hint<>'' then
    ShowMessage(Image13.Hint);
end;

procedure TForm7.Image11Click(Sender: TObject);
begin
  if Image11.Hint<>'' then
    ShowMessage(Image11.Hint);
end;

procedure TForm7.futureImage1Click(Sender: TObject);
begin
  if futureImage1.Hint<>'' then
    ShowMessage(futureImage1.Hint);
end;

procedure TForm7.dxButton13Click(Sender: TObject);
begin
  Form7.FormStyle:=fsNormal;
  Bui_ExecuteWait(Form1.TempRep+'mplayer.exe', '-vo directx "'+Form1.Edit1.Text+'"',SW_HIDE);
  Form7.FormStyle:=fsStayOnTop;
end;

end.
